## workflow 0.11.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
set(CMAKE_SKIP_RPATH TRUE)

project(
	workflow
	VERSION 0.11.7
	LANGUAGES C CXX
)

if (CYGWIN)
	message(FATAL_ERROR "Sorry, DO NOT support Cygwin")
endif ()

if (MINGW)
	message(FATAL_ERROR "Sorry, DO NOT support MinGW")
endif ()

include(GNUInstallDirs)

set(CMAKE_CONFIG_INSTALL_FILE ${PROJECT_BINARY_DIR}/config.toinstall.cmake)
set(CMAKE_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
set(INC_DIR ${PROJECT_SOURCE_DIR}/_include CACHE PATH "workflow inc")
set(LIB_DIR ${PROJECT_SOURCE_DIR}/_lib CACHE PATH "workflow lib")

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIB_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIB_DIR})

add_custom_target(
	LINK_HEADERS ALL
	COMMENT "link headers..."
)

INCLUDE(CMakeLists_Headers.txt)

macro(makeLink src dest target)
	add_custom_command(
		TARGET ${target} PRE_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest}
		DEPENDS ${dest}
	)
endmacro()

add_custom_command(
	TARGET LINK_HEADERS PRE_BUILD
	COMMAND ${CMAKE_COMMAND} -E make_directory ${INC_DIR}/${PROJECT_NAME}
)

foreach(header_file ${INCLUDE_HEADERS} ${INCLUDE_KERNEL_HEADERS})
	string(REPLACE "/" ";" arr ${header_file})
	list(GET arr -1 file_name)
	makeLink(${PROJECT_SOURCE_DIR}/${header_file} ${INC_DIR}/${PROJECT_NAME}/${file_name} LINK_HEADERS)
endforeach()

message("CMAKE_C_FLAGS_DEBUG is ${CMAKE_C_FLAGS_DEBUG}")
message("CMAKE_C_FLAGS_RELEASE is ${CMAKE_C_FLAGS_RELEASE}")
message("CMAKE_C_FLAGS_RELWITHDEBINFO is ${CMAKE_C_FLAGS_RELWITHDEBINFO}")
message("CMAKE_C_FLAGS_MINSIZEREL is ${CMAKE_C_FLAGS_MINSIZEREL}")

message("CMAKE_CXX_FLAGS_DEBUG is ${CMAKE_CXX_FLAGS_DEBUG}")
message("CMAKE_CXX_FLAGS_RELEASE is ${CMAKE_CXX_FLAGS_RELEASE}")
message("CMAKE_CXX_FLAGS_RELWITHDEBINFO is ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
message("CMAKE_CXX_FLAGS_MINSIZEREL is ${CMAKE_CXX_FLAGS_MINSIZEREL}")

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
	if (APPLE)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
	endif()
endif ()

add_subdirectory(src)

####CONFIG

include(CMakePackageConfigHelpers)
set(CONFIG_INC_DIR ${INC_DIR})
set(CONFIG_LIB_DIR ${LIB_DIR})
configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${PROJECT_SOURCE_DIR}/${PROJECT_NAME}-config.cmake
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR
)

set(CONFIG_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(CONFIG_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${CMAKE_CONFIG_INSTALL_FILE}
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR
)

write_basic_package_version_file(
	${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
	VERSION ${WORKFLOW_VERSION}
	COMPATIBILITY AnyNewerVersion 
)

install(
	FILES ${CMAKE_CONFIG_INSTALL_FILE}
	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	COMPONENT devel
	RENAME ${PROJECT_NAME}-config.cmake
)

install(
	FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	COMPONENT devel
)

install(
	FILES ${INCLUDE_HEADERS} ${INCLUDE_KERNEL_HEADERS}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
	COMPONENT devel
)

install(
	FILES README.md
	DESTINATION "${CMAKE_INSTALL_DOCDIR}-${PROJECT_VERSION}"
	COMPONENT devel
)

=== benchmark/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(benchmark
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

find_library(LIBRT rt)
find_package(OpenSSL REQUIRED)
find_package(workflow REQUIRED CONFIG HINTS ..)
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${WORKFLOW_LIB_DIR})

if (WIN32)
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
		if (APPLE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
		endif()
endif ()

set(BENCHMARK_LIST
	benchmark-01-http_server
	benchmark-02-http_server_long_req
)

if (APPLE)
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
else ()
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
endif ()

foreach(src ${BENCHMARK_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(workflow_test
		LANGUAGES C CXX
)

find_library(LIBRT rt)
find_package(OpenSSL REQUIRED)
find_package(workflow REQUIRED CONFIG HINTS ..)
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${WORKFLOW_LIB_DIR})

find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
set(memcheck_command ${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

enable_testing()

set(CXX_STD "c++14")

find_package(GTest REQUIRED)

if (WIN32)
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
		if (APPLE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
		endif()
endif ()

set(TEST_LIST
	task_unittest
	algo_unittest
	http_unittest
	redis_unittest
	mysql_unittest
	facilities_unittest
	graph_unittest
	memory_unittest
	upstream_unittest
	dns_unittest
	resource_unittest
	uriparser_unittest
)

if (APPLE)
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
else ()
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
endif ()

foreach(src ${TEST_LIST})
	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc)
	target_link_libraries(${src} ${WORKFLOW_LIB} GTest::GTest GTest::Main)
	add_test(${src} ${src})
	add_dependencies(check ${src})
endforeach()

if (NOT ${CMAKE_MEMORYCHECK_COMMAND} STREQUAL "CMAKE_MEMORYCHECK_COMMAND-NOTFOUND")
	foreach(src ${TEST_LIST})
		add_test(${src}-memory-check ${memcheck_command} ./${src})
	endforeach()
endif ()

=== tutorial/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(tutorial
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

if(ANDROID)
	link_directories(${OPENSSL_LINK_DIR})
else()
	find_library(LIBRT rt)
	find_package(OpenSSL REQUIRED)
endif()
find_package(workflow REQUIRED CONFIG HINTS ..)
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${WORKFLOW_LIB_DIR})

if (KAFKA STREQUAL "y")
	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
	include_directories(${SNAPPY_INCLUDE_PATH})
endif ()

if (WIN32)
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
		if (APPLE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
		endif()
endif ()

set(TUTORIAL_LIST
	tutorial-00-helloworld
	tutorial-01-wget
	tutorial-04-http_echo_server
	tutorial-05-http_proxy
	tutorial-06-parallel_wget
	tutorial-07-sort_task
	tutorial-08-matrix_multiply
	tutorial-09-http_file_server
	tutorial-11-graph_task
	tutorial-15-name_service
	tutorial-17-dns_cli
)

if (APPLE)
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
elseif (ANDROID)
	set(WORKFLOW_LIB workflow ssl crypto c)
else ()
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
endif ()

foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()

if (NOT REDIS STREQUAL "n")
set(TUTORIAL_LIST
	tutorial-02-redis_cli
	tutorial-03-wget_to_redis
	tutorial-18-redis_subscriber
)
foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()
endif()

if (NOT MYSQL STREQUAL "n")
set(TUTORIAL_LIST
	tutorial-12-mysql_cli
)
foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()
endif()

if (NOT CONSUL STREQUAL "n")
set(TUTORIAL_LIST
	tutorial-14-consul_cli
)
foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()
endif()

if (KAFKA STREQUAL "y")
	add_executable("kafka_cli" "tutorial-13-kafka_cli.cc")
	target_link_libraries("kafka_cli" wfkafka ${WORKFLOW_LIB} z snappy lz4 zstd)
endif ()

set(DIR10 tutorial-10-user_defined_protocol)
add_executable(server ${DIR10}/server.cc ${DIR10}/message.cc)
add_executable(client ${DIR10}/client.cc ${DIR10}/message.cc)
add_executable(server-uds ${DIR10}/server-uds.cc ${DIR10}/message.cc)
add_executable(client-uds ${DIR10}/client-uds.cc ${DIR10}/message.cc)
target_link_libraries(server ${WORKFLOW_LIB})
target_link_libraries(client ${WORKFLOW_LIB})
target_link_libraries(server-uds ${WORKFLOW_LIB})
target_link_libraries(client-uds ${WORKFLOW_LIB})

set_target_properties(server PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
set_target_properties(client PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
set_target_properties(server-uds PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
set_target_properties(client-uds PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})

set(DIR16 tutorial-16-graceful_restart)
add_executable(bootstrap ${DIR16}/bootstrap.c)
add_executable(bootstrap_server ${DIR16}/server.cc)
target_link_libraries(bootstrap_server ${WORKFLOW_LIB})

set_target_properties(bootstrap PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR16})
set_target_properties(bootstrap_server PROPERTIES OUTPUT_NAME "server"
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR16})

=== src/client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(client)

set(SRC
	WFDnsClient.cc
)

if (NOT REDIS STREQUAL "n")
	set(SRC
		${SRC}
		WFRedisSubscriber.cc
	)
endif ()

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		WFMySQLConnection.cc
	)
endif ()

if (NOT CONSUL STREQUAL "n")
	set(SRC
		${SRC}
		WFConsulClient.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		WFKafkaClient.cc
	)
	add_library("client_kafka" OBJECT ${SRC})
endif ()

=== src/util/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(util)

set(SRC
	json_parser.c
	EncodeStream.cc
	StringUtil.cc
	URIParser.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		crc32c.c
	)
	add_library("util_kafka" OBJECT ${SRC})
endif ()

=== debian/changelog ===
workflow (0.11.7-1) unstable; urgency=medium

  * New upstream version 0.11.7
  * d/patches: Refresh patches and remove a patch

 -- Lance Lin <lq27267@gmail.com>  Tue, 07 Jan 2025 21:34:34 +0700

=== debian/control ===
Source: workflow
Section: libs
Priority: optional
Maintainer: Lance Lin <lq27267@gmail.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
               libgtest-dev <!nocheck>,
               libssl-dev
Standards-Version: 4.7.0
Homepage: https://github.com/sogou/workflow
Vcs-Git: https://salsa.debian.org/debian/workflow.git
Vcs-Browser: https://salsa.debian.org/debian/workflow
Rules-Requires-Root: no

Package: libworkflow0t64
Provides: ${t64:Provides}
Architecture: any
Multi-Arch: same
Breaks: libworkflow0 (<< ${source:Version}), libworkflow1 (<< 0.10.1-1)
Replaces: libworkflow0, libworkflow1 (<< 0.10.1-1)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Parallel computing and asynchronous web server engine
 Workflow can be used as a scalable web server to handle a variety
 of server workflows. It can be used to orchestrate complex
 relationships between computing and networking.  Workflow currently
 supports protocols for HTTP, Redis, MySQL, and Kafka.
 .
 This package contains the runtime library.

Package: libworkflow-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libworkflow1 (<< 0.10.1-1)
Replaces: libworkflow1 (<< 0.10.1-1)
Depends: ${misc:Depends}, ${shlibs:Depends}, libworkflow0t64 (= ${binary:Version})
Description: Parallel computing and asynchronous web server engine development files
 Workflow can be used as a scalable web server to handle a variety
 of server workflows. It can be used to orchestrate complex
 relationships between computing and networking.  Workflow currently
 supports protocols for HTTP, Redis, MySQL, and Kafka.
 .
 This package contains the development header files.

## workflow 0.11.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.7
+	VERSION 0.11.8
 	LANGUAGES C CXX
 )

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

if(ANDROID)
	include_directories(${OPENSSL_INCLUDE_DIR})
	link_directories(${OPENSSL_LINK_DIR})
else()
	find_package(OpenSSL REQUIRED)
endif ()

include_directories(${OPENSSL_INCLUDE_DIR} ${INC_DIR}/workflow)

if (KAFKA STREQUAL "y")
	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
	find_library(SNAPPY_LIB NAMES snappy)
	if ((NOT SNAPPY_INCLUDE_PATH) OR (NOT SNAPPY_LIB))
		message(FATAL_ERROR "Fail to find snappy with KAFKA=y")
	endif ()
	include_directories(${SNAPPY_INCLUDE_PATH})
endif ()

add_subdirectory(kernel)
add_subdirectory(util)
add_subdirectory(manager)
add_subdirectory(protocol)
add_subdirectory(factory)
add_subdirectory(nameservice)
add_subdirectory(server)
add_subdirectory(client)

add_dependencies(kernel LINK_HEADERS)
add_dependencies(util LINK_HEADERS)
add_dependencies(manager LINK_HEADERS)
add_dependencies(protocol LINK_HEADERS)
add_dependencies(factory LINK_HEADERS)
add_dependencies(nameservice LINK_HEADERS)
add_dependencies(server LINK_HEADERS)
add_dependencies(client LINK_HEADERS)

set(STATIC_LIB_NAME ${PROJECT_NAME}-static)
set(SHARED_LIB_NAME ${PROJECT_NAME}-shared)

add_library(
	${STATIC_LIB_NAME} STATIC
	$<TARGET_OBJECTS:kernel>
	$<TARGET_OBJECTS:util>
	$<TARGET_OBJECTS:manager>
	$<TARGET_OBJECTS:protocol>
	$<TARGET_OBJECTS:factory>
	$<TARGET_OBJECTS:nameservice>
	$<TARGET_OBJECTS:server>
	$<TARGET_OBJECTS:client>
)

add_library(
	${SHARED_LIB_NAME} SHARED
	$<TARGET_OBJECTS:kernel>
	$<TARGET_OBJECTS:util>
	$<TARGET_OBJECTS:manager>
	$<TARGET_OBJECTS:protocol>
	$<TARGET_OBJECTS:factory>
	$<TARGET_OBJECTS:nameservice>
	$<TARGET_OBJECTS:server>
	$<TARGET_OBJECTS:client>
)

if(ANDROID)
	target_link_libraries(${SHARED_LIB_NAME} ssl crypto c)
	target_link_libraries(${STATIC_LIB_NAME} ssl crypto c)
else()
	target_link_libraries(${SHARED_LIB_NAME} OpenSSL::SSL OpenSSL::Crypto pthread)
	target_link_libraries(${STATIC_LIB_NAME} OpenSSL::SSL OpenSSL::Crypto pthread)
endif ()

set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

if (KAFKA STREQUAL "y")
	add_dependencies(client_kafka LINK_HEADERS)
	add_dependencies(util_kafka LINK_HEADERS)
	add_dependencies(protocol_kafka LINK_HEADERS)
	add_dependencies(factory_kafka LINK_HEADERS)

	set(KAFKA_STATIC_LIB_NAME "wfkafka-static")
	add_library(
		${KAFKA_STATIC_LIB_NAME} STATIC
		$<TARGET_OBJECTS:client_kafka>
		$<TARGET_OBJECTS:util_kafka>
		$<TARGET_OBJECTS:protocol_kafka>
		$<TARGET_OBJECTS:factory_kafka>
	)
	set_target_properties(${KAFKA_STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka")

	set(KAFKA_SHARED_LIB_NAME "wfkafka-shared")
	add_library(
		${KAFKA_SHARED_LIB_NAME} SHARED
		$<TARGET_OBJECTS:client_kafka>
		$<TARGET_OBJECTS:util_kafka>
		$<TARGET_OBJECTS:protocol_kafka>
		$<TARGET_OBJECTS:factory_kafka>
	)
	if (APPLE)
		target_link_libraries(${KAFKA_SHARED_LIB_NAME}
							  ${SHARED_LIB_NAME} z lz4 zstd ${SNAPPY_LIB})
	else ()
		target_link_libraries(${KAFKA_SHARED_LIB_NAME} ${SHARED_LIB_NAME})
	endif ()
	set_target_properties(${KAFKA_SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka" VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
endif ()

install(
	TARGETS ${STATIC_LIB_NAME}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

install(
	TARGETS ${SHARED_LIB_NAME}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

if (KAFKA STREQUAL "y")
	install(
		TARGETS ${KAFKA_STATIC_LIB_NAME}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)
	install(
		TARGETS ${KAFKA_SHARED_LIB_NAME}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)
endif ()

target_include_directories(${STATIC_LIB_NAME} BEFORE PUBLIC
	"$<BUILD_INTERFACE:${INC_DIR}>"
	"$<INSTALL_INTERFACE:${INC_DIR}>")
target_include_directories(${SHARED_LIB_NAME} BEFORE PUBLIC
	"$<BUILD_INTERFACE:${INC_DIR}>"
	"$<INSTALL_INTERFACE:${INC_DIR}>")
if (KAFKA STREQUAL "y")
	target_include_directories(${KAFKA_STATIC_LIB_NAME} BEFORE PUBLIC
		"$<BUILD_INTERFACE:${INC_DIR}>"
		"$<INSTALL_INTERFACE:${INC_DIR}>")
	target_include_directories(${KAFKA_SHARED_LIB_NAME} BEFORE PUBLIC
		"$<BUILD_INTERFACE:${INC_DIR}>"
		"$<INSTALL_INTERFACE:${INC_DIR}>")
endif ()

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -46,6 +46,7 @@
 	tutorial-11-graph_task
 	tutorial-15-name_service
 	tutorial-17-dns_cli
+	tutorial-19-dns_server
 )
 
 if (APPLE)

=== debian/changelog ===
workflow (0.11.8-1) unstable; urgency=medium

  * New upstream version 0.11.8
  * Standards-Version: 4.7.2 (routine-update)

 -- Lance Lin <lq27267@gmail.com>  Wed, 05 Mar 2025 19:51:43 +0700

## workflow 0.11.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.8
+	VERSION 0.11.10
 	LANGUAGES C CXX
 )

=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 find_package(workflow REQUIRED CONFIG HINTS ..)
 include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
 link_directories(${WORKFLOW_LIB_DIR})
+find_library(WORKFLOW_LIB NAMES libworkflow.a workflow HINTS ${WORKFLOW_LIB_DIR})
 
 if (WIN32)
 		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
@@ -31,14 +32,14 @@
 )
 
 if (APPLE)
-	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
+	set(LIB ${WORKFLOW_LIB} pthread OpenSSL::SSL OpenSSL::Crypto)
 else ()
-	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
+	set(LIB ${WORKFLOW_LIB} pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
 endif ()
 
 foreach(src ${BENCHMARK_LIST})
 	string(REPLACE "-" ";" arr ${src})
 	list(GET arr -1 bin_name)
 	add_executable(${bin_name} ${src}.cc)
-	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
+	target_link_libraries(${bin_name} ${LIB})
 endforeach()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -10,12 +10,29 @@
 include_directories(${OPENSSL_INCLUDE_DIR} ${INC_DIR}/workflow)
 
 if (KAFKA STREQUAL "y")
+	find_package(ZLIB REQUIRED)
+	include_directories(${ZLIB_INCLUDE_DIRS})
+
 	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
 	find_library(SNAPPY_LIB NAMES snappy)
 	if ((NOT SNAPPY_INCLUDE_PATH) OR (NOT SNAPPY_LIB))
 		message(FATAL_ERROR "Fail to find snappy with KAFKA=y")
 	endif ()
 	include_directories(${SNAPPY_INCLUDE_PATH})
+
+	find_path(ZSTD_INCLUDE_PATH NAMES zstd.h)
+	find_library(ZSTD_LIB NAMES zstd)
+	if ((NOT ZSTD_INCLUDE_PATH) OR (NOT ZSTD_LIB))
+		message(FATAL_ERROR "Fail to find zstd with KAFKA=y")
+	endif ()
+	include_directories(${ZSTD_INCLUDE_PATH})
+
+	find_path(LZ4_INCLUDE_PATH NAMES lz4.h)
+	find_library(LZ4_LIB NAMES lz4)
+	if ((NOT LZ4_INCLUDE_PATH) OR (NOT LZ4_LIB))
+		message(FATAL_ERROR "Fail to find lz4 with KAFKA=y")
+	endif ()
+	include_directories(${LZ4_INCLUDE_PATH})
 endif ()
 
 add_subdirectory(kernel)
@@ -64,11 +81,11 @@
 )
 
 if(ANDROID)
-	target_link_libraries(${SHARED_LIB_NAME} ssl crypto c)
-	target_link_libraries(${STATIC_LIB_NAME} ssl crypto c)
+	target_link_libraries(${SHARED_LIB_NAME} PUBLIC ssl crypto c)
+	target_link_libraries(${STATIC_LIB_NAME} PUBLIC ssl crypto c)
 else()
-	target_link_libraries(${SHARED_LIB_NAME} OpenSSL::SSL OpenSSL::Crypto pthread)
-	target_link_libraries(${STATIC_LIB_NAME} OpenSSL::SSL OpenSSL::Crypto pthread)
+	target_link_libraries(${SHARED_LIB_NAME} PUBLIC OpenSSL::SSL OpenSSL::Crypto pthread)
+	target_link_libraries(${STATIC_LIB_NAME} PUBLIC OpenSSL::SSL OpenSSL::Crypto pthread)
 endif ()
 
 set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
@@ -88,6 +105,8 @@
 		$<TARGET_OBJECTS:protocol_kafka>
 		$<TARGET_OBJECTS:factory_kafka>
 	)
+	target_link_libraries(${KAFKA_STATIC_LIB_NAME} PUBLIC
+				${STATIC_LIB_NAME} ZLIB::ZLIB ${LZ4_LIB} ${ZSTD_LIB} ${SNAPPY_LIB})
 	set_target_properties(${KAFKA_STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka")
 
 	set(KAFKA_SHARED_LIB_NAME "wfkafka-shared")
@@ -98,12 +117,8 @@
 		$<TARGET_OBJECTS:protocol_kafka>
 		$<TARGET_OBJECTS:factory_kafka>
 	)
-	if (APPLE)
-		target_link_libraries(${KAFKA_SHARED_LIB_NAME}
-							  ${SHARED_LIB_NAME} z lz4 zstd ${SNAPPY_LIB})
-	else ()
-		target_link_libraries(${KAFKA_SHARED_LIB_NAME} ${SHARED_LIB_NAME})
-	endif ()
+	target_link_libraries(${KAFKA_SHARED_LIB_NAME} PUBLIC
+				${SHARED_LIB_NAME} ZLIB::ZLIB ${LZ4_LIB} ${ZSTD_LIB} ${SNAPPY_LIB})
 	set_target_properties(${KAFKA_SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka" VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 endif ()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
 find_package(workflow REQUIRED CONFIG HINTS ..)
 include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
 link_directories(${WORKFLOW_LIB_DIR})
+find_library(WORKFLOW_LIB NAMES libworkflow.a workflow HINTS ${WORKFLOW_LIB_DIR})
 
 find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
 set(memcheck_command ${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full)
@@ -50,14 +51,14 @@
 )
 
 if (APPLE)
-	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
+	set(LIB ${WORKFLOW_LIB} pthread OpenSSL::SSL OpenSSL::Crypto)
 else ()
-	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
+	set(LIB ${WORKFLOW_LIB} pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
 endif ()
 
 foreach(src ${TEST_LIST})
 	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc)
-	target_link_libraries(${src} ${WORKFLOW_LIB} GTest::GTest GTest::Main)
+	target_link_libraries(${src} ${LIB} GTest::GTest GTest::Main)
 	add_test(${src} ${src})
 	add_dependencies(check ${src})
 endforeach()

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -14,13 +14,15 @@
 	find_library(LIBRT rt)
 	find_package(OpenSSL REQUIRED)
 endif()
+
 find_package(workflow REQUIRED CONFIG HINTS ..)
 include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
 link_directories(${WORKFLOW_LIB_DIR})
 
+find_library(WORKFLOW_LIB NAMES libworkflow.a workflow HINTS ${WORKFLOW_LIB_DIR})
+
 if (KAFKA STREQUAL "y")
-	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
-	include_directories(${SNAPPY_INCLUDE_PATH})
+	find_library(WFKAFKA_LIB NAMES libwfkafka.a wfkafka HINTS ${WORKFLOW_LIB_DIR})
 endif ()
 
 if (WIN32)
@@ -50,18 +52,18 @@
 )
 
 if (APPLE)
-	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
+	set(LIB ${WORKFLOW_LIB} pthread OpenSSL::SSL OpenSSL::Crypto)
 elseif (ANDROID)
-	set(WORKFLOW_LIB workflow ssl crypto c)
+	set(LIB ${WORKFLOW_LIB} ssl crypto c)
 else ()
-	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
+	set(LIB ${WORKFLOW_LIB} pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
 endif ()
 
 foreach(src ${TUTORIAL_LIST})
 	string(REPLACE "-" ";" arr ${src})
 	list(GET arr -1 bin_name)
 	add_executable(${bin_name} ${src}.cc)
-	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
+	target_link_libraries(${bin_name} ${LIB})
 endforeach()
 
 if (NOT REDIS STREQUAL "n")
@@ -74,7 +76,7 @@
 	string(REPLACE "-" ";" arr ${src})
 	list(GET arr -1 bin_name)
 	add_executable(${bin_name} ${src}.cc)
-	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
+	target_link_libraries(${bin_name} ${LIB})
 endforeach()
 endif()
 
@@ -86,7 +88,7 @@
 	string(REPLACE "-" ";" arr ${src})
 	list(GET arr -1 bin_name)
 	add_executable(${bin_name} ${src}.cc)
-	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
+	target_link_libraries(${bin_name} ${LIB})
 endforeach()
 endif()
 
@@ -98,13 +100,17 @@
 	string(REPLACE "-" ";" arr ${src})
 	list(GET arr -1 bin_name)
 	add_executable(${bin_name} ${src}.cc)
-	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
+	target_link_libraries(${bin_name} ${LIB})
 endforeach()
 endif()
 
 if (KAFKA STREQUAL "y")
 	add_executable("kafka_cli" "tutorial-13-kafka_cli.cc")
-	target_link_libraries("kafka_cli" wfkafka ${WORKFLOW_LIB} z snappy lz4 zstd)
+	find_package(ZLIB REQUIRED)
+	find_library(SNAPPY_LIB NAMES snappy)
+	find_library(LZ4_LIB NAMES lz4)
+	find_library(ZSTD_LIB NAMES zstd)
+	target_link_libraries("kafka_cli" ${WFKAFKA_LIB} ${LIB} ZLIB::ZLIB ${SNAPPY_LIB} ${LZ4_LIB} ${ZSTD_LIB})
 endif ()
 
 set(DIR10 tutorial-10-user_defined_protocol)
@@ -112,10 +118,10 @@
 add_executable(client ${DIR10}/client.cc ${DIR10}/message.cc)
 add_executable(server-uds ${DIR10}/server-uds.cc ${DIR10}/message.cc)
 add_executable(client-uds ${DIR10}/client-uds.cc ${DIR10}/message.cc)
-target_link_libraries(server ${WORKFLOW_LIB})
-target_link_libraries(client ${WORKFLOW_LIB})
-target_link_libraries(server-uds ${WORKFLOW_LIB})
-target_link_libraries(client-uds ${WORKFLOW_LIB})
+target_link_libraries(server ${LIB})
+target_link_libraries(client ${LIB})
+target_link_libraries(server-uds ${LIB})
+target_link_libraries(client-uds ${LIB})
 
 set_target_properties(server PROPERTIES
 	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
@@ -129,7 +135,7 @@
 set(DIR16 tutorial-16-graceful_restart)
 add_executable(bootstrap ${DIR16}/bootstrap.c)
 add_executable(bootstrap_server ${DIR16}/server.cc)
-target_link_libraries(bootstrap_server ${WORKFLOW_LIB})
+target_link_libraries(bootstrap_server ${LIB})
 
 set_target_properties(bootstrap PROPERTIES
 	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR16})

=== src/client/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 
 set(SRC
 	WFDnsClient.cc
+	WFHttpChunkedClient.cc
 )
 
 if (NOT REDIS STREQUAL "n")

=== src/factory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(factory)

set(SRC
	WFGraphTask.cc
	DnsTaskImpl.cc
	WFTaskFactory.cc
	Workflow.cc
	HttpTaskImpl.cc
	WFResourcePool.cc
	WFMessageQueue.cc
	FileTaskImpl.cc
)

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		MySQLTaskImpl.cc
	)
endif ()

if (NOT REDIS STREQUAL "n")
	set(SRC
		${SRC}
		RedisTaskImpl.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		KafkaTaskImpl.cc
	)
	add_library("factory_kafka" OBJECT ${SRC})
	set_property(SOURCE KafkaTaskImpl.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
endif ()

=== src/kernel/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(kernel)

if (CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
	set(IOSERVICE_FILE IOService_linux.cc)
elseif (UNIX)
	set(IOSERVICE_FILE IOService_thread.cc)
else ()
	message(FATAL_ERROR "IOService unsupported.")
endif ()

set(SRC
	${IOSERVICE_FILE}
	mpoller.c
	poller.c
	rbtree.c
	msgqueue.c
	thrdpool.c
	CommRequest.cc
	CommScheduler.cc
	Communicator.cc
	Executor.cc
	SubTask.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== src/manager/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(manager)

set(SRC
	DnsCache.cc
	RouteManager.cc
	WFGlobal.cc
)

if (NOT UPSTREAM STREQUAL "n")
	set(SRC
		${SRC}
		UpstreamManager.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== src/nameservice/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(nameservice)

set(SRC
	WFNameService.cc
	WFDnsResolver.cc
)

if (NOT UPSTREAM STREQUAL "n")
	set(SRC
		${SRC}
		WFServiceGovernance.cc
		UpstreamPolicies.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== src/protocol/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(protocol)

set(SRC
	PackageWrapper.cc
	SSLWrapper.cc
	dns_parser.c
	DnsMessage.cc
	DnsUtil.cc
	http_parser.c
	HttpMessage.cc
	HttpUtil.cc
	TLVMessage.cc
)

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		mysql_stream.c
		mysql_parser.c
		mysql_byteorder.c
		MySQLMessage.cc
		MySQLResult.cc
		MySQLUtil.cc
	)
endif ()

if (NOT REDIS STREQUAL "n")
	set(SRC
		${SRC}
		redis_parser.c
		RedisMessage.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		kafka_parser.c
		KafkaMessage.cc
		KafkaDataTypes.cc
		KafkaResult.cc
	)
	add_library("protocol_kafka" OBJECT ${SRC})
	set_property(SOURCE KafkaMessage.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
endif ()

=== src/server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(server)

set(SRC
	WFServer.cc
)

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		WFMySQLServer.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== debian/changelog ===
workflow (0.11.10-2) unstable; urgency=medium

  * d/patches: Fix FTBFS with gtest (Closes: #1114442)

 -- Lance Lin <lq27267@gmail.com>  Mon, 15 Sep 2025 19:57:05 +0700

workflow (0.11.10-1) unstable; urgency=medium

  * New upstream version 0.11.10
  * d/copyright: Update copyright year to 2025

 -- Lance Lin <lq27267@gmail.com>  Tue, 12 Aug 2025 20:45:54 +0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                cmake,
                libgtest-dev <!nocheck>,
                libssl-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/sogou/workflow
 Vcs-Git: https://salsa.debian.org/debian/workflow.git
 Vcs-Browser: https://salsa.debian.org/debian/workflow

=== debian/tests/control ===
Tests: unittests
Depends: @, @builddeps@
Restrictions: allow-stderr

## workflow 0.11.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 
 set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(
 	workflow
-	VERSION 0.11.10
+	VERSION 0.11.11
 	LANGUAGES C CXX
 )
 
@@ -38,7 +38,6 @@
 	add_custom_command(
 		TARGET ${target} PRE_BUILD
 		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest}
-		DEPENDS ${dest}
 	)
 endmacro()

=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 
 set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 
 if(ANDROID)
 	include_directories(${OPENSSL_INCLUDE_DIR})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 
 set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 
 set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
 
@@ -107,9 +107,26 @@
 if (KAFKA STREQUAL "y")
 	add_executable("kafka_cli" "tutorial-13-kafka_cli.cc")
 	find_package(ZLIB REQUIRED)
+	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
 	find_library(SNAPPY_LIB NAMES snappy)
+	if ((NOT SNAPPY_INCLUDE_PATH) OR (NOT SNAPPY_LIB))
+		message(FATAL_ERROR "Fail to find snappy with KAFKA=y")
+	endif ()
+	include_directories(${SNAPPY_INCLUDE_PATH})
+
+	find_path(ZSTD_INCLUDE_PATH NAMES zstd.h)
+	find_library(ZSTD_LIB NAMES zstd)
+	if ((NOT ZSTD_INCLUDE_PATH) OR (NOT ZSTD_LIB))
+		message(FATAL_ERROR "Fail to find zstd with KAFKA=y")
+	endif ()
+	include_directories(${ZSTD_INCLUDE_PATH})
+
+	find_path(LZ4_INCLUDE_PATH NAMES lz4.h)
 	find_library(LZ4_LIB NAMES lz4)
-	find_library(ZSTD_LIB NAMES zstd)
+	if ((NOT LZ4_INCLUDE_PATH) OR (NOT LZ4_LIB))
+		message(FATAL_ERROR "Fail to find lz4 with KAFKA=y")
+	endif ()
+	include_directories(${LZ4_INCLUDE_PATH})
 	target_link_libraries("kafka_cli" ${WFKAFKA_LIB} ${LIB} ZLIB::ZLIB ${SNAPPY_LIB} ${LZ4_LIB} ${ZSTD_LIB})
 endif ()

=== src/client/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(client)
 
 set(SRC

=== src/factory/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(factory)
 
 set(SRC
@@ -33,5 +33,4 @@
 		KafkaTaskImpl.cc
 	)
 	add_library("factory_kafka" OBJECT ${SRC})
-	set_property(SOURCE KafkaTaskImpl.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
 endif ()

=== src/kernel/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(kernel)
 
 if (CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")

=== src/manager/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(manager)
 
 set(SRC

=== src/nameservice/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(nameservice)
 
 set(SRC

=== src/protocol/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(protocol)
 
 set(SRC
@@ -43,5 +43,4 @@
 		KafkaResult.cc
 	)
 	add_library("protocol_kafka" OBJECT ${SRC})
-	set_property(SOURCE KafkaMessage.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
 endif ()

=== src/server/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.6)
+cmake_minimum_required(VERSION 3.10)
 project(server)
 
 set(SRC

=== debian/changelog ===
workflow (0.11.11-1) unstable; urgency=medium

  * New upstream version 0.11.11
  * d/patches: Refresh patches

 -- Lance Lin <lq27267@gmail.com>  Mon, 22 Sep 2025 21:32:27 +0700

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export INSTALL_PREFIX = /usr/

%:
	dh $@ --buildsystem=cmake

override_dh_auto_test:
ifneq (mips64el,$(DEB_BUILD_ARCH))
	dh_auto_test --builddir=test -- VERBOSE=1
endif

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d+\.\d+\.\d+)\S*\.tar\.gz/workflow-$1\.tar\.gz/ \
  https://github.com/sogou/workflow/tags .*/v?(\d+\.\d+\.\d+)\.tar\.gz

## workflow 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.11
+	VERSION 1.0.0
 	LANGUAGES C CXX
 )
 
@@ -62,16 +62,11 @@
 message("CMAKE_CXX_FLAGS_RELWITHDEBINFO is ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
 message("CMAKE_CXX_FLAGS_MINSIZEREL is ${CMAKE_CXX_FLAGS_MINSIZEREL}")
 
-if (WIN32)
-	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
-else ()
-	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
-	if (APPLE)
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
-	endif()
-endif ()
+set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
+if (APPLE)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+endif()
 
 add_subdirectory(src)

=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -15,16 +15,11 @@
 link_directories(${WORKFLOW_LIB_DIR})
 find_library(WORKFLOW_LIB NAMES libworkflow.a workflow HINTS ${WORKFLOW_LIB_DIR})
 
-if (WIN32)
-		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
-else ()
-		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
-		if (APPLE)
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
-		endif()
-endif ()
+set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
+if (APPLE)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+endif()
 
 set(BENCHMARK_LIST
 	benchmark-01-http_server

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -20,20 +20,15 @@
 
 enable_testing()
 
-set(CXX_STD "c++14")
+set(CXX_STD "c++17")
 
 find_package(GTest REQUIRED)
 
-if (WIN32)
-		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
-else ()
-		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
-		if (APPLE)
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
-		endif()
-endif ()
+set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
+if (APPLE)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+endif()
 
 set(TEST_LIST
 	task_unittest

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -25,16 +25,11 @@
 	find_library(WFKAFKA_LIB NAMES libwfkafka.a wfkafka HINTS ${WORKFLOW_LIB_DIR})
 endif ()
 
-if (WIN32)
-		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
-else ()
-		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
-		if (APPLE)
-			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
-		endif()
-endif ()
+set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
+if (APPLE)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+endif()
 
 set(TUTORIAL_LIST
 	tutorial-00-helloworld

=== debian/changelog ===
workflow (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0
    - Includes SONAME bump (libworkflow0t64 -> libworkflow1)
  * Standards-Version: 4.7.3 (routine-update)
  * d/patches: Refresh patches
  * d/control: Remove redundant fields
  * d/watch: Update to version 5
  * d/copyright: Replace BSD-2-Clause and zlib with ISC, update
      copyrights for crc32.(h/c), and update debian/* copyright
      year to 2026

 -- Lance Lin <lq27267@gmail.com>  Thu, 12 Feb 2026 18:34:08 +0700

=== debian/control ===
Source: workflow
Section: libs
Maintainer: Lance Lin <lq27267@gmail.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
               libgtest-dev <!nocheck>,
               libssl-dev
Standards-Version: 4.7.3
Homepage: https://github.com/sogou/workflow
Vcs-Git: https://salsa.debian.org/debian/workflow.git
Vcs-Browser: https://salsa.debian.org/debian/workflow

Package: libworkflow1
Provides: ${t64:Provides}
Architecture: any
Multi-Arch: same
Breaks: libworkflow0 (<< ${source:Version}), libworkflow0t64
Replaces: libworkflow0, libworkflow0t64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Parallel computing and asynchronous web server engine
 Workflow can be used as a scalable web server to handle a variety
 of server workflows. It can be used to orchestrate complex
 relationships between computing and networking.  Workflow currently
 supports protocols for HTTP, Redis, MySQL, and Kafka.
 .
 This package contains the runtime library.

Package: libworkflow-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libworkflow1 (= ${binary:Version})
Description: Parallel computing and asynchronous web server engine development files
 Workflow can be used as a scalable web server to handle a variety
 of server workflows. It can be used to orchestrate complex
 relationships between computing and networking.  Workflow currently
 supports protocols for HTTP, Redis, MySQL, and Kafka.
 .
 This package contains the development header files.

=== debian/watch ===
Version: 5
Template: GitHub
Owner: sogou
Project: workflow
